// one line to give the program's name and an idea of what it does.
// Copyright (C) 2005  name of Borja Snchez Zamorano
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using System.Reflection;
using CalWidget;
using BorSanZaNET;
using MonoCalendar.MonthCalendar;
using System.Resources;
using System.Threading;
using MonoCalendar.i18n;

namespace MonoCalendar {
	
	public class MonoCalendarApp : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem menuItemNewEvent;
		private System.Windows.Forms.ToolBarButton toolBarButton1;
		private MonoCalendar.ListView.ListView listView2;
		private System.Windows.Forms.MenuItem menuItemImport;
		private System.Windows.Forms.MenuItem menuItemEdit;
		private System.Windows.Forms.ToolBarButton toolBarButtonWeek;
		private System.Windows.Forms.Panel panelCalendar;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem menuItemViewMonths;
		private System.Windows.Forms.ToolBarButton toolBarButtonPrev;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItemGPL;
		private MonoCalendar.info info1;
		private System.Windows.Forms.MenuItem menuItemViewToday;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItemAbout;
		private System.Windows.Forms.MenuItem menuItemNotifyExit;
		private System.Windows.Forms.Panel panelListView;
		private CalWidget.Calendar wc;
		private System.Windows.Forms.MenuItem menuItemViewPrev;
		private System.Windows.Forms.ToolBarButton toolBarButtonListView;
		private System.Windows.Forms.MenuItem menuItemPreferences;
		private System.Windows.Forms.ToolBarButton toolBarButtonInfo;
		private System.Windows.Forms.MenuItem menuItemNewCalendar;
		private System.Windows.Forms.ToolBarButton toolBarButtonZoomLess;
		private System.Windows.Forms.ToolBarButton toolBarButtonZoomMore;
		private System.Windows.Forms.MenuItem menuItemClose;
		private System.Windows.Forms.ContextMenu contextMenuNotifyIcon;
		private System.Windows.Forms.Panel panelInfo;
		private System.Windows.Forms.MenuItem menuItemExport;
		private System.Windows.Forms.ToolBarButton toolBarButtonNewCalendar;
		private System.Windows.Forms.MenuItem menuItemView;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.MenuItem menuItemLanguage;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private MonoCalendar.MonthCalendar.MonthCalendar monthCalendar2;
		private System.Windows.Forms.MenuItem menuItemExit;
		private System.Windows.Forms.MenuItem menuItemViewDays;
		private System.Windows.Forms.Panel panelMonthCalendar;
		private System.Windows.Forms.MenuItem menuItemViewWeeks;
		private System.Windows.Forms.ToolBarButton toolBarButtonDay;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItemCheckUpdate;
		private System.Windows.Forms.MenuItem menuItemFile;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItemViewNext;
		private System.Windows.Forms.ToolBarButton toolBarButtonNext;
		private System.Windows.Forms.NotifyIcon notifyIcon1;
		private System.Windows.Forms.MenuItem menuItemOpenMC;
		private System.Windows.Forms.ToolBarButton toolBarButtonMonth;
		private System.Windows.Forms.ToolBarButton toolBarButton2;
		private System.Windows.Forms.ToolBarButton toolBarButton3;
		public static MiniGConf Config;
		
		private MonoCalendar.ControlSplitter controlSplitter1;
		private MonoCalendar.ControlSplitter controlSplitter2;
		private MonoCalendar.ControlSplitter controlSplitterAll;

		UpdateMonoCalendar updateCalendar;
		string version;
		
		void setControlSplitters()
		{
			this.SuspendLayout();
			controlSplitter1 = new MonoCalendar.ControlSplitter();
			controlSplitter1.Orientation = 2;
			controlSplitter1.Controls.Add(panelListView);
			controlSplitter1.Controls.Add(panelMonthCalendar);
			controlSplitter1.MinPos = 100;
			controlSplitter1.MaxPos = 500;
			controlSplitter1.BeginResize += new System.EventHandler(this.controlSplitter1BeginResize);
			controlSplitter1.FinishResize += new System.EventHandler(this.controlSplitter1FinishResize);
			
			controlSplitter2 = new MonoCalendar.ControlSplitter();
			controlSplitter2.Controls.Add(panelCalendar);
			controlSplitter2.Controls.Add(panelInfo);
			controlSplitter2.ControlHidden = true;
			controlSplitter2.Pos = 200;
			controlSplitter2.MaxPos = 250;
			controlSplitter2.FinishResize += new System.EventHandler(this.controlSplitter2FinishResize);
			
			controlSplitterAll = new MonoCalendar.ControlSplitter();
			controlSplitterAll.Controls.Add(controlSplitter1);
			controlSplitterAll.Controls.Add(controlSplitter2);
			controlSplitterAll.ControlBigger = 1;
			controlSplitterAll.Resizable = false;
			controlSplitterAll.Pos = 168;
			this.Controls.Add(controlSplitterAll);
			
			this.ResumeLayout(false);
		}
		
		void Translate()
		{
			menuItemClose.Text = tr.GetString("&Close");
			menuItemNotifyExit.Text = tr.GetString("&Close");
			menuItemOpenMC.Text = tr.GetString("&Open MonoCalendar");
			menuItemFile.Text = tr.GetString("&File");
			menuItemEdit.Text = tr.GetString("&Edit");
			menuItemView.Text = tr.GetString("&View");
			menuItemHelp.Text = tr.GetString("&Help");
			menuItemNewEvent.Text = tr.GetString("New &event");
			menuItemNewCalendar.Text = tr.GetString("New c&alendar");
			menuItemImport.Text = tr.GetString("&Import...");
			menuItemExport.Text = tr.GetString("E&xport...");
			menuItemPreferences.Text = tr.GetString("&Preferences");
			menuItemGPL.Text = tr.GetString("&GPL...");
			menuItemAbout.Text = tr.GetString("&About us...");
			toolBarButtonDay.Text = tr.GetString("Day");
			toolBarButtonWeek.Text = tr.GetString("Week");
			toolBarButtonMonth.Text = tr.GetString("Month");
			toolBarButtonListView.Text = tr.GetString("Lateral");
			toolBarButtonNewCalendar.ToolTipText = tr.GetString("New Calendar");
			toolBarButtonNext.ToolTipText = tr.GetString("Next");
			toolBarButtonPrev.ToolTipText = tr.GetString("Previous");
			toolBarButtonInfo.ToolTipText = tr.GetString("Information");
			toolBarButtonZoomLess.ToolTipText = tr.GetString("Zoom out");
			toolBarButtonZoomMore.ToolTipText = tr.GetString("Zoom in");
			listView2.Title = tr.GetString("Calendars");
			menuItemCheckUpdate.Text = tr.GetString("&Check updates");
			menuItemViewToday.Text = tr.GetString("&Go Today");
			menuItemViewDays.Text = tr.GetString("View &days");
			menuItemViewMonths.Text = tr.GetString("View &months");
			menuItemViewWeeks.Text = tr.GetString("View &weeks");
			menuItemViewNext.Text = tr.GetString("&Next");
			menuItemViewPrev.Text = tr.GetString("&Previous");
			menuItemLanguage.Text = tr.GetString("&Select Language");
			wc.Translate("NewEvent", tr.GetString("New event"));
			wc.Translate("DateFormatShort", tr.GetString("M/%d"));
			wc.Translate("DateFormatNormal", tr.GetString("ddd %d"));
			wc.Translate("DateFormatLong", tr.GetString("ddd, MMM %d"));
			wc.Translate("DateFormatLong2", tr.GetString("dddd, MMMM %d"));
		}
		
		public MonoCalendarApp(string windowsCulture)
		{
			string Path = System.IO.Path.Combine(System.Environment.GetFolderPath (System.Environment.SpecialFolder.Personal), ".config");
			Path = System.IO.Path.Combine(Path, "MonoCalendar");
			DirectoryInfo d = new DirectoryInfo (Path);
			if (!d.Exists) d.Create();
			Config = new MiniGConf(System.IO.Path.Combine(Path, "settings.xml"));
			
			tr.Me.LoadLanguage((string) Config.Get("Language", Thread.CurrentThread.CurrentUICulture.Name));
			
			InitializeComponent();

			listView2.OnCheckedChanged += new MonoCalendar.ListView.ItemHandler(ListView1CheckedChanged);
			listView2.OnSelectedChanged += new EventHandler(ListView1SelectedChanged);
			listView2.OnAfterLabelEdit += new MonoCalendar.ListView.ItemHandler(ListView1AfterLabelEdit);
			
			ImageList imageList1 = new ImageList();
			imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			imageList1.ImageSize = new System.Drawing.Size(16, 16);
			imageList1.TransparentColor = System.Drawing.Color.Transparent;
			imageList1.Images.Add(GetResourceImage("plus.png"));
			imageList1.Images.Add(GetResourceImage("viewList.png"));
			imageList1.Images.Add(GetResourceImage("left.png"));
			imageList1.Images.Add(GetResourceImage("day.png"));
			imageList1.Images.Add(GetResourceImage("week.png"));
			imageList1.Images.Add(GetResourceImage("month.png"));
			imageList1.Images.Add(GetResourceImage("right.png"));
			imageList1.Images.Add(GetResourceImage("information.png"));
			imageList1.Images.Add(GetResourceImage("zoom-less.png"));
			imageList1.Images.Add(GetResourceImage("zoom-more.png"));
			this.toolBarButtonNewCalendar.ImageIndex = 0;
			this.toolBarButtonListView.ImageIndex = 1;
			this.toolBarButtonPrev.ImageIndex = 2;
			this.toolBarButtonDay.ImageIndex = 3;
			this.toolBarButtonWeek.ImageIndex = 4;
			this.toolBarButtonMonth.ImageIndex = 5;
			this.toolBarButtonNext.ImageIndex = 6;
			this.toolBarButtonInfo.ImageIndex = 7;
			this.toolBarButtonZoomLess.ImageIndex = 8;
			this.toolBarButtonZoomMore.ImageIndex = 9;
			toolBarButtonInfo.Visible = false;

			toolBar1.ImageList = imageList1;
			
			setControlSplitters();
			
			Version v = Assembly.GetEntryAssembly().GetName().Version;
			version = String.Format("{0}.{1}.{2}", v.Major, v.Minor, v.Build);
			this.Text = String.Format("MonoCalendar {0}", version);
			
			monthCalendar2.Date = DateTime.Now;
			wc.Date = monthCalendar2.Date;
			
			MonoCalendar.ListView.ListViewItem item1;
			foreach (string files in System.IO.Directory.GetFiles(Path, "*.ics")) {
				CalData aux = wc.NewCalData();
				aux.LoadICS(files);
				
				item1 = new MonoCalendar.ListView.ListViewItem();
				item1.Checked = true;
				item1.Text = aux.CalendarName;
				item1.Color = aux.ColorBorder;
				item1.Tag = aux;
				listView2.Items.Add(item1);
			}
			
			if (listView2.Items.Count < 1) {
				CalData aux = wc.NewCalData();
				aux.CalendarName = tr.GetString("Personal");
				item1 = new MonoCalendar.ListView.ListViewItem();
				item1.Text = aux.CalendarName;
				item1.Color = aux.ColorBorder;
				item1.Checked = true;
				item1.Tag = aux;
				listView2.Items.Add(item1);
				
				aux = wc.NewCalData();
				aux.CalendarName = tr.GetString("Work");
				item1 = new MonoCalendar.ListView.ListViewItem();
				item1.Text = aux.CalendarName;
				item1.Color = aux.ColorBorder;
				item1.Checked = true;
				item1.Tag = aux;
				listView2.Items.Add(item1);
			}
			wc.UpdateCalendar();
			
			Config.OnChange += new MiniGConf.KeyHandler(OnChangeConfig);
			
			System.Globalization.DateTimeFormatInfo dtfi; // = new System.Globalization.DateTimeFormatInfo();
			dtfi = System.Globalization.CultureInfo.CurrentCulture.DateTimeFormat;
			Config.Set("FirstDayOfWeek", (uint) Config.Get("FirstDayOfWeek", (uint) dtfi.FirstDayOfWeek));
			wc.DaysByWeek = (int) Config.Get("DaysByWeek", (int) 7);
			wc.TimeFormat = (int) Config.Get("TimeFormat", (int) 1);
			monthCalendar2.DaysByWeek = (int) Config.Get("DaysByWeek", (int) 7);
			wc.Alpha = (int) Config.Get("AlphaEvent", (int) 200);

			wc.StartHour = (int) Config.Get("StartHour", (int) 8);
			wc.EndHour = (int) Config.Get("EndHour", (int) 18);
			wc.HoursViewed = (uint) Config.Get("HoursViewed", (uint) 12);
			Config.Set("StartHour", (int) wc.StartHour);
			Config.Set("EndHour", (int) wc.EndHour);
			Config.Set("HoursViewed", (uint) wc.HoursViewed);
			Config.Set("NotifyIcon", (bool) Config.Get("NotifyIcon", (bool) false));
			
			switch ((CalWidget.CalendarStyle) Config.Get("CalendarStyle", (int) CalendarStyle.Week)) {
				case CalWidget.CalendarStyle.Day:
					menuItemViewDays.PerformClick();
					break;
				case CalWidget.CalendarStyle.Month:
					menuItemViewMonths.PerformClick();
					break;
				default:
					menuItemViewWeeks.PerformClick();
					break;
			}
			
			updateCalendar = new UpdateMonoCalendar(windowsCulture);
			updateCalendar.NewVersion += new EventHandler(UpdateNewVersion);
			Translate();
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			bool mutexWasCreated = false;
			Mutex m = new Mutex(true, "MonoCalendar", out mutexWasCreated);
			if (mutexWasCreated) {
				new MonoCalendar.i18n.tr();
				MonoCalendarApp app = new MonoCalendarApp(Thread.CurrentThread.CurrentUICulture.Name);
				Application.Run(app);
				m.ReleaseMutex();
			}
		}
		
		Image GetResourceImage (string name)
		{
			Assembly assembly = System.Reflection.Assembly.GetCallingAssembly();
			System.IO.Stream s = assembly.GetManifestResourceStream (name);
			return Image.FromStream(s);
		}
		
		#region Cdigo generado por el Diseador de Windows Forms
		
		void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MonoCalendarApp));
			this.toolBarButton3 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton2 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonMonth = new System.Windows.Forms.ToolBarButton();
			this.menuItemOpenMC = new System.Windows.Forms.MenuItem();
			this.notifyIcon1 = new System.Windows.Forms.NotifyIcon(this.components);
			this.toolBarButtonNext = new System.Windows.Forms.ToolBarButton();
			this.menuItemViewNext = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItemFile = new System.Windows.Forms.MenuItem();
			this.menuItemCheckUpdate = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.toolBarButtonDay = new System.Windows.Forms.ToolBarButton();
			this.menuItemViewWeeks = new System.Windows.Forms.MenuItem();
			this.panelMonthCalendar = new System.Windows.Forms.Panel();
			this.menuItemViewDays = new System.Windows.Forms.MenuItem();
			this.menuItemExit = new System.Windows.Forms.MenuItem();
			this.monthCalendar2 = new MonoCalendar.MonthCalendar.MonthCalendar();
			this.menuItemHelp = new System.Windows.Forms.MenuItem();
			this.menuItemLanguage = new System.Windows.Forms.MenuItem();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.menuItemView = new System.Windows.Forms.MenuItem();
			this.toolBarButtonNewCalendar = new System.Windows.Forms.ToolBarButton();
			this.menuItemExport = new System.Windows.Forms.MenuItem();
			this.panelInfo = new System.Windows.Forms.Panel();
			this.contextMenuNotifyIcon = new System.Windows.Forms.ContextMenu();
			this.menuItemClose = new System.Windows.Forms.MenuItem();
			this.toolBarButtonZoomMore = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonZoomLess = new System.Windows.Forms.ToolBarButton();
			this.menuItemNewCalendar = new System.Windows.Forms.MenuItem();
			this.toolBarButtonInfo = new System.Windows.Forms.ToolBarButton();
			this.menuItemPreferences = new System.Windows.Forms.MenuItem();
			this.toolBarButtonListView = new System.Windows.Forms.ToolBarButton();
			this.menuItemViewPrev = new System.Windows.Forms.MenuItem();
			this.wc = new CalWidget.Calendar();
			this.panelListView = new System.Windows.Forms.Panel();
			this.menuItemNotifyExit = new System.Windows.Forms.MenuItem();
			this.menuItemAbout = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItemViewToday = new System.Windows.Forms.MenuItem();
			this.info1 = new MonoCalendar.info();
			this.menuItemGPL = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.toolBarButtonPrev = new System.Windows.Forms.ToolBarButton();
			this.menuItemViewMonths = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.panelCalendar = new System.Windows.Forms.Panel();
			this.toolBarButtonWeek = new System.Windows.Forms.ToolBarButton();
			this.menuItemEdit = new System.Windows.Forms.MenuItem();
			this.menuItemImport = new System.Windows.Forms.MenuItem();
			this.listView2 = new MonoCalendar.ListView.ListView();
			this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
			this.menuItemNewEvent = new System.Windows.Forms.MenuItem();
			this.panelMonthCalendar.SuspendLayout();
			this.panelInfo.SuspendLayout();
			this.panelListView.SuspendLayout();
			this.panelCalendar.SuspendLayout();
			this.SuspendLayout();
			// 
			// toolBarButton3
			// 
			this.toolBarButton3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			this.toolBarButton3.Visible = false;
			// 
			// toolBarButton2
			// 
			this.toolBarButton2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButtonMonth
			// 
			this.toolBarButtonMonth.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.toolBarButtonMonth.Text = "Mes";
			// 
			// menuItemOpenMC
			// 
			this.menuItemOpenMC.DefaultItem = true;
			this.menuItemOpenMC.Index = 0;
			this.menuItemOpenMC.Text = "&Open MonoCalendar";
			this.menuItemOpenMC.Click += new System.EventHandler(this.MenuItemOpenMCClick);
			// 
			// notifyIcon1
			// 
			this.notifyIcon1.ContextMenu = this.contextMenuNotifyIcon;
			this.notifyIcon1.Icon = ((System.Drawing.Icon)(resources.GetObject("notifyIcon1.Icon")));
			this.notifyIcon1.Text = "MonoCalendar";
			this.notifyIcon1.DoubleClick += new System.EventHandler(this.NotifyIcon1DoubleClick);
			// 
			// toolBarButtonNext
			// 
			this.toolBarButtonNext.ToolTipText = "Siguiente";
			// 
			// menuItemViewNext
			// 
			this.menuItemViewNext.Index = 6;
			this.menuItemViewNext.Text = "Siguie&nte";
			this.menuItemViewNext.Click += new System.EventHandler(this.MenuItemViewNextClick);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 1;
			this.menuItem8.Text = "-";
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 2;
			this.menuItem9.Text = "-";
			// 
			// menuItemFile
			// 
			this.menuItemFile.Index = 0;
			this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuItemNewEvent,
						this.menuItemNewCalendar,
						this.menuItem9,
						this.menuItemImport,
						this.menuItemExport,
						this.menuItem7,
						this.menuItemClose});
			this.menuItemFile.Text = "&Archivo";
			// 
			// menuItemCheckUpdate
			// 
			this.menuItemCheckUpdate.Index = 2;
			this.menuItemCheckUpdate.Text = "&Buscar actualizaciones";
			this.menuItemCheckUpdate.Click += new System.EventHandler(this.MenuItemCheckUpdateClick);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 5;
			this.menuItem7.Text = "-";
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.Text = "-";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "-";
			// 
			// toolBarButtonDay
			// 
			this.toolBarButtonDay.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.toolBarButtonDay.Text = "Día";
			// 
			// menuItemViewWeeks
			// 
			this.menuItemViewWeeks.Index = 3;
			this.menuItemViewWeeks.Shortcut = System.Windows.Forms.Shortcut.Ctrl2;
			this.menuItemViewWeeks.Text = "Ver por &semanas";
			this.menuItemViewWeeks.Click += new System.EventHandler(this.MenuItemViewWeeksClick);
			// 
			// panelMonthCalendar
			// 
			this.panelMonthCalendar.BackColor = System.Drawing.Color.White;
			this.panelMonthCalendar.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panelMonthCalendar.Controls.Add(this.monthCalendar2);
			this.panelMonthCalendar.Location = new System.Drawing.Point(8, 264);
			this.panelMonthCalendar.Name = "panelMonthCalendar";
			this.panelMonthCalendar.Size = new System.Drawing.Size(141, 160);
			this.panelMonthCalendar.TabIndex = 3;
			// 
			// menuItemViewDays
			// 
			this.menuItemViewDays.Index = 2;
			this.menuItemViewDays.Shortcut = System.Windows.Forms.Shortcut.Ctrl1;
			this.menuItemViewDays.Text = "Ver por &das";
			this.menuItemViewDays.Click += new System.EventHandler(this.MenuItemViewDaysClick);
			// 
			// menuItemExit
			// 
			this.menuItemExit.Index = -1;
			this.menuItemExit.Text = "";
			// 
			// monthCalendar2
			// 
			this.monthCalendar2.Date = new System.DateTime(2005, 3, 22, 0, 0, 0, 0);
			this.monthCalendar2.DaysByWeek = 7;
			this.monthCalendar2.Dock = System.Windows.Forms.DockStyle.Fill;
			// TODO: Error while generating statement : Tipo primitivo no vlido: System.UInt32. Slo se pueden utilizar los tipos primitivos compatibles con CLS. Utilice CodeObjectCreateExpression.
			this.monthCalendar2.Location = new System.Drawing.Point(0, 0);
			this.monthCalendar2.MonthsViewed = 1;
			this.monthCalendar2.Name = "monthCalendar2";
			this.monthCalendar2.OldHeight = 173;
			this.monthCalendar2.Size = new System.Drawing.Size(137, 156);
			this.monthCalendar2.Sizing = false;
			this.monthCalendar2.Style = MonoCalendar.MonthCalendar.MonthCalendarStyle.Week;
			this.monthCalendar2.TabIndex = 12;
			this.monthCalendar2.Text = "monthCalendar2";
			this.monthCalendar2.VisibleHeight = 173;
			this.monthCalendar2.SizeHeightChanged += new System.EventHandler(this.MonthCalendar2SizeHeightChanged);
			this.monthCalendar2.DateChanged += new System.EventHandler(this.MonthCalendar2DateChanged);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 3;
			this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuItemGPL,
						this.menuItem2,
						this.menuItemCheckUpdate,
						this.menuItem11,
						this.menuItemAbout});
			this.menuItemHelp.Text = "&Ayuda";
			// 
			// menuItemLanguage
			// 
			this.menuItemLanguage.Index = 0;
			this.menuItemLanguage.Text = "&Select Language";
			this.menuItemLanguage.Click += new System.EventHandler(this.MenuItemLanguageClick);
			// 
			// toolBar1
			// 
			this.toolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
						this.toolBarButtonNewCalendar,
						this.toolBarButtonListView,
						this.toolBarButton1,
						this.toolBarButtonPrev,
						this.toolBarButtonDay,
						this.toolBarButtonWeek,
						this.toolBarButtonMonth,
						this.toolBarButtonNext,
						this.toolBarButton2,
						this.toolBarButtonZoomLess,
						this.toolBarButtonZoomMore,
						this.toolBarButton3,
						this.toolBarButtonInfo});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(592, 28);
			this.toolBar1.TabIndex = 9;
			this.toolBar1.TextAlign = System.Windows.Forms.ToolBarTextAlign.Right;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.ToolBar1ButtonClick);
			// 
			// menuItemView
			// 
			this.menuItemView.Index = 2;
			this.menuItemView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuItemViewToday,
						this.menuItem8,
						this.menuItemViewDays,
						this.menuItemViewWeeks,
						this.menuItemViewMonths,
						this.menuItem12,
						this.menuItemViewNext,
						this.menuItemViewPrev});
			this.menuItemView.Text = "&Ver";
			// 
			// toolBarButtonNewCalendar
			// 
			this.toolBarButtonNewCalendar.ToolTipText = "Nuevo Calendario";
			// 
			// menuItemExport
			// 
			this.menuItemExport.Index = 4;
			this.menuItemExport.Text = "Exportar...";
			this.menuItemExport.Click += new System.EventHandler(this.MenuItemExportClick);
			// 
			// panelInfo
			// 
			this.panelInfo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panelInfo.Controls.Add(this.info1);
			this.panelInfo.Location = new System.Drawing.Point(560, 48);
			this.panelInfo.Name = "panelInfo";
			this.panelInfo.Size = new System.Drawing.Size(120, 376);
			this.panelInfo.TabIndex = 11;
			// 
			// contextMenuNotifyIcon
			// 
			this.contextMenuNotifyIcon.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuItemOpenMC,
						this.menuItemNotifyExit});
			// 
			// menuItemClose
			// 
			this.menuItemClose.Index = 6;
			this.menuItemClose.Text = "&Cerrar";
			this.menuItemClose.Click += new System.EventHandler(this.MenuItemCloseClick);
			// 
			// toolBarButtonZoomMore
			// 
			this.toolBarButtonZoomMore.ToolTipText = "Zoom +";
			// 
			// toolBarButtonZoomLess
			// 
			this.toolBarButtonZoomLess.ToolTipText = "Zoom -";
			// 
			// menuItemNewCalendar
			// 
			this.menuItemNewCalendar.Index = 1;
			this.menuItemNewCalendar.Text = "Nuevo calendario";
			this.menuItemNewCalendar.Click += new System.EventHandler(this.MenuItemNewCalendarClick);
			// 
			// toolBarButtonInfo
			// 
			this.toolBarButtonInfo.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.toolBarButtonInfo.ToolTipText = "Informacin";
			this.toolBarButtonInfo.Visible = false;
			// 
			// menuItemPreferences
			// 
			this.menuItemPreferences.Index = 2;
			this.menuItemPreferences.Text = "&Preferencias";
			this.menuItemPreferences.Click += new System.EventHandler(this.MenuItemPreferencesClick);
			// 
			// toolBarButtonListView
			// 
			this.toolBarButtonListView.Pushed = true;
			this.toolBarButtonListView.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.toolBarButtonListView.Text = "Lateral";
			// 
			// menuItemViewPrev
			// 
			this.menuItemViewPrev.Index = 7;
			this.menuItemViewPrev.Text = "&Anterior";
			this.menuItemViewPrev.Click += new System.EventHandler(this.MenuItemViewPrevClick);
			// 
			// wc
			// 
			this.wc.Alpha = 50;
			this.wc.Date = new System.DateTime(2005, 2, 17, 0, 0, 0, 0);
			this.wc.DaysByWeek = 7;
			this.wc.Dock = System.Windows.Forms.DockStyle.Fill;
			this.wc.EndHour = 24;
			// TODO: Error while generating statement : Tipo primitivo no vlido: System.UInt32. Slo se pueden utilizar los tipos primitivos compatibles con CLS. Utilice CodeObjectCreateExpression.
			// TODO: Error while generating statement : Tipo primitivo no vlido: System.UInt32. Slo se pueden utilizar los tipos primitivos compatibles con CLS. Utilice CodeObjectCreateExpression.
			this.wc.Location = new System.Drawing.Point(0, 0);
			this.wc.Name = "wc";
			this.wc.Size = new System.Drawing.Size(388, 372);
			this.wc.StartHour = 0;
			this.wc.Style = CalWidget.CalendarStyle.Week;
			this.wc.TabIndex = 0;
			this.wc.TimeFormat = 1;
			this.wc.StyleChanged += new System.EventHandler(this.WcStyleChanged);
			this.wc.CalendarChanged += new System.EventHandler(this.WcCalendarChanged);
			this.wc.DateChanged += new System.EventHandler(this.WcDateChanged);
			// 
			// panelListView
			// 
			this.panelListView.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panelListView.Controls.Add(this.listView2);
			this.panelListView.Location = new System.Drawing.Point(8, 48);
			this.panelListView.Name = "panelListView";
			this.panelListView.Size = new System.Drawing.Size(141, 208);
			this.panelListView.TabIndex = 0;
			// 
			// menuItemNotifyExit
			// 
			this.menuItemNotifyExit.Index = 1;
			this.menuItemNotifyExit.Text = "&Exit";
			this.menuItemNotifyExit.Click += new System.EventHandler(this.MenuItemNotifyExitClick);
			// 
			// menuItemAbout
			// 
			this.menuItemAbout.Index = 4;
			this.menuItemAbout.Text = "&Acerca de...";
			this.menuItemAbout.Click += new System.EventHandler(this.MenuItemAboutClick);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuItemFile,
						this.menuItemEdit,
						this.menuItemView,
						this.menuItemHelp});
			// 
			// menuItemViewToday
			// 
			this.menuItemViewToday.Index = 0;
			this.menuItemViewToday.Shortcut = System.Windows.Forms.Shortcut.CtrlT;
			this.menuItemViewToday.Text = "&Ir a Hoy";
			this.menuItemViewToday.Click += new System.EventHandler(this.MenuItemViewTodayClick);
			// 
			// info1
			// 
			this.info1.BackColor = System.Drawing.Color.White;
			this.info1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.info1.Location = new System.Drawing.Point(0, 0);
			this.info1.Name = "info1";
			this.info1.Size = new System.Drawing.Size(116, 372);
			this.info1.TabIndex = 0;
			// 
			// menuItemGPL
			// 
			this.menuItemGPL.Index = 0;
			this.menuItemGPL.Text = "&GPL...";
			this.menuItemGPL.Click += new System.EventHandler(this.MenuItemGPLClick);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 3;
			this.menuItem11.Text = "-";
			// 
			// toolBarButtonPrev
			// 
			this.toolBarButtonPrev.ToolTipText = "Anterior";
			// 
			// menuItemViewMonths
			// 
			this.menuItemViewMonths.Index = 4;
			this.menuItemViewMonths.Shortcut = System.Windows.Forms.Shortcut.Ctrl3;
			this.menuItemViewMonths.Text = "Ver por &meses";
			this.menuItemViewMonths.Click += new System.EventHandler(this.MenuItemViewMonthsClick);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 5;
			this.menuItem12.Text = "-";
			// 
			// panelCalendar
			// 
			this.panelCalendar.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panelCalendar.Controls.Add(this.wc);
			this.panelCalendar.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.panelCalendar.Location = new System.Drawing.Point(160, 48);
			this.panelCalendar.Name = "panelCalendar";
			this.panelCalendar.Size = new System.Drawing.Size(392, 376);
			this.panelCalendar.TabIndex = 2;
			// 
			// toolBarButtonWeek
			// 
			this.toolBarButtonWeek.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.toolBarButtonWeek.Text = "Semana";
			// 
			// menuItemEdit
			// 
			this.menuItemEdit.Index = 1;
			this.menuItemEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuItemLanguage,
						this.menuItem1,
						this.menuItemPreferences});
			this.menuItemEdit.Text = "&Editar";
			// 
			// menuItemImport
			// 
			this.menuItemImport.Index = 3;
			this.menuItemImport.Text = "Importar...";
			this.menuItemImport.Click += new System.EventHandler(this.MenuItemImportClick);
			// 
			// listView2
			// 
			this.listView2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView2.Location = new System.Drawing.Point(0, 0);
			this.listView2.Name = "listView2";
			this.listView2.Size = new System.Drawing.Size(137, 204);
			this.listView2.TabIndex = 1;
			this.listView2.Text = "listView2";
			this.listView2.Title = "";
			this.listView2.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ListView2KeyDown);
			// 
			// toolBarButton1
			// 
			this.toolBarButton1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// menuItemNewEvent
			// 
			this.menuItemNewEvent.Index = 0;
			this.menuItemNewEvent.Text = "Nuevo evento";
			// 
			// MonoCalendarApp
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 423);
			this.Controls.Add(this.panelInfo);
			this.Controls.Add(this.panelListView);
			this.Controls.Add(this.panelMonthCalendar);
			this.Controls.Add(this.panelCalendar);
			this.Controls.Add(this.toolBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.MinimumSize = new System.Drawing.Size(600, 450);
			this.Name = "MonoCalendarApp";
			this.Text = "MonoCalendar";
			this.Resize += new System.EventHandler(this.MonoCalendarAppResize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MonoCalendarAppClosing);
			this.Load += new System.EventHandler(this.MonoCalendarAppLoad);
			this.Closed += new System.EventHandler(this.MonoCalendarAppClosed);
			this.panelMonthCalendar.ResumeLayout(false);
			this.panelInfo.ResumeLayout(false);
			this.panelListView.ResumeLayout(false);
			this.panelCalendar.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion
		
		void OnChangeConfig(string key, object value)
		{
			switch (key) {
				case "NotifyIcon":
					notifyIcon1.Visible = (bool) value;
					break;
				case "FirstDayOfWeek":
					wc.FirstDayOfWeek = (uint) value;
					monthCalendar2.FirstDayOfWeek = (uint)value;
					break;
				case "DaysByWeek":
					wc.DaysByWeek = (int) value;
					monthCalendar2.DaysByWeek = (int) value;
					break;
				case "StartHour":
					wc.StartHour = (int) value;
					break;
				case "EndHour":
					wc.EndHour = (int) value;
					break;
				case "Language":
					tr.Me.LoadLanguage((string) value);
					Translate();
					monthCalendar2.UpdateCalendar();
					wc.UpdateCalendar();
					break;
				case "TimeFormat":
					wc.TimeFormat = (int) value;
					break;
				case "CalendarStyle":
					wc.Style = (CalWidget.CalendarStyle) value;
					switch ((CalWidget.CalendarStyle) value) {
						case CalWidget.CalendarStyle.Week:
							monthCalendar2.Style = MonthCalendarStyle.Week;
							break;
						case CalWidget.CalendarStyle.Month:
							monthCalendar2.Style = MonthCalendarStyle.Month;
							break;
						default:
							monthCalendar2.Style = MonthCalendarStyle.Day;
							break;
					}
					break;
				case "HoursViewed":
					wc.HoursViewed = (uint) value;
					break;
				case "AlphaEvent":
					wc.Alpha = (int) value;
					break;
			}
		}
		
		void ResizeMonthCalendar()
		{
			controlSplitter1.Pos = monthCalendar2.VisibleHeight + (panelMonthCalendar.Height - panelMonthCalendar.ClientRectangle.Height) + 3;
		}
		
		void ResizeInfo()
		{
			if (!controlSplitter2.ControlHidden) {
				if (controlSplitter2.Pos < 100) {
					controlSplitter2.ControlHidden = true;
				}
			}
			controlSplitter2.Pos = 200;
			toolBar1.Buttons[9].Pushed = !controlSplitter2.ControlHidden;
		}
		
		void controlSplitter1BeginResize(object sender, System.EventArgs e)
		{
			monthCalendar2.Sizing = true;
		}
		
		void controlSplitter1FinishResize(object sender, System.EventArgs e)
		{
			ResizeMonthCalendar();
			monthCalendar2.Sizing = false;
		}
		
		void MonthCalendar2SizeHeightChanged(object sender, System.EventArgs e)
		{
			ResizeMonthCalendar();
		}
		
		void controlSplitter2FinishResize(object sender, System.EventArgs e)
		{
			ResizeInfo();
		}
		
		void MonoCalendarAppResize(object sender, System.EventArgs e)
		{
			if (WindowState != System.Windows.Forms.FormWindowState.Minimized) {
				if ((this.ClientRectangle.Width==0) || (this.ClientRectangle.Height==0)) return;
				int separator = 5;
				controlSplitter1.MaxPos = this.ClientRectangle.Height - (toolBar1.Bottom + 159);
				controlSplitterAll.Pos = 137 + (panelMonthCalendar.Width - panelMonthCalendar.ClientRectangle.Width) + 2;
				controlSplitterAll.SetBounds(separator, toolBar1.Bottom + separator, this.ClientRectangle.Width - (separator*2), this.ClientRectangle.Height - (toolBar1.Bottom + (separator*2)));
				ResizeMonthCalendar();
				ResizeInfo();
			}
		}
		
		void MenuItemNewCalendarClick(object sender, System.EventArgs e)
		{
			bool finded = true;
			int cont = 1;
			string text = "";
			while (finded==true) {
				finded = false;
				if (cont == 1)
					text = tr.GetString("Without title");
				else
					text = String.Format("{0} {1}", tr.GetString("Without title"), cont);
				foreach (CalData aux2 in wc.CalendarData) {
					if (text == aux2.CalendarName) {
						finded = true;
						cont++;
					}
				}
			}
			CalData aux = wc.NewCalData();
			aux.CalendarName = text;
			MonoCalendar.ListView.ListViewItem item1 = new MonoCalendar.ListView.ListViewItem();
			item1.Text = aux.CalendarName;
			item1.Checked = true;
			item1.Color = aux.ColorBorder;
			item1.Tag = (CalData) aux;
			listView2.Items.Add(item1);
			listView2.Selected = item1;
			listView2.EditLabel();
		}
		
		void ToolBar1ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch(toolBar1.Buttons.IndexOf(e.Button))
			{
				case 0:
					menuItemNewCalendar.PerformClick();
					break;
				case 1:
					controlSplitterAll.ControlHidden = !controlSplitterAll.ControlHidden;
					break;
				case 3:
					menuItemViewPrev.PerformClick();
					break;
				case 4:
					menuItemViewDays.PerformClick();
					break;
				case 5:
					menuItemViewWeeks.PerformClick();
					break;
				case 6:
					menuItemViewMonths.PerformClick();
					break;
				case 7:
					menuItemViewNext.PerformClick();
					break;
				case 9:
					wc.HoursViewed++;
					Config.Set("HoursViewed", (uint) wc.HoursViewed);
					break;
				case 10:
					wc.HoursViewed--;
					Config.Set("HoursViewed", (uint) wc.HoursViewed);
					break;
				case 12:
					controlSplitter2.ControlHidden = !controlSplitter2.ControlHidden;
					break;
			}
		}
		
		void WcStyleChanged(object sender, System.EventArgs e)
		{
			menuItemViewDays.PerformClick();
		}
		
		void MenuItemViewDaysClick(object sender, System.EventArgs e)
		{
			toolBar1.Buttons[4].Pushed=true;
			toolBar1.Buttons[5].Pushed=false;
			toolBar1.Buttons[6].Pushed=false;
			Config.Set("CalendarStyle", (int) CalendarStyle.Day);
		}
		
		void MenuItemViewWeeksClick(object sender, System.EventArgs e)
		{
			toolBar1.Buttons[4].Pushed=false;
			toolBar1.Buttons[5].Pushed=true;
			toolBar1.Buttons[6].Pushed=false;
			Config.Set("CalendarStyle", (int) CalendarStyle.Week);
		}
		
		void MenuItemViewMonthsClick(object sender, System.EventArgs e)
		{
			toolBar1.Buttons[4].Pushed=false;
			toolBar1.Buttons[5].Pushed=false;
			toolBar1.Buttons[6].Pushed=true;
			Config.Set("CalendarStyle", (int) CalendarStyle.Month);
		}
		
		void MenuItemViewNextClick(object sender, System.EventArgs e)
		{
			if (toolBar1.Buttons[4].Pushed) {
				monthCalendar2.Date = monthCalendar2.Date.AddDays(1);
				wc.Date = monthCalendar2.Date;
				return;
			}
			if (toolBar1.Buttons[5].Pushed) {
				monthCalendar2.Date = monthCalendar2.Date.AddDays(7);
				wc.Date = monthCalendar2.Date;
				return;
			}
			if (toolBar1.Buttons[6].Pushed) {
				monthCalendar2.Date = monthCalendar2.Date.AddMonths(1);
				wc.Date = monthCalendar2.Date;
				return;
			}
		}
		
		void MenuItemViewPrevClick(object sender, System.EventArgs e)
		{
			if (toolBar1.Buttons[4].Pushed) {
				monthCalendar2.Date = monthCalendar2.Date.AddDays(-1);
				wc.Date = monthCalendar2.Date;
				return;
			}
			if (toolBar1.Buttons[5].Pushed) {
				monthCalendar2.Date = monthCalendar2.Date.AddDays(-7);
				wc.Date = monthCalendar2.Date;
				return;
			}
			if (toolBar1.Buttons[6].Pushed) {
				monthCalendar2.Date = monthCalendar2.Date.AddMonths(-1);
				wc.Date = monthCalendar2.Date;
				return;
			}
		}
		
		void MenuItemViewTodayClick(object sender, System.EventArgs e)
		{
			monthCalendar2.Date = System.DateTime.Today;
			wc.Date = monthCalendar2.Date;
		}
		
		void MenuItemPreferencesClick(object sender, System.EventArgs e)
		{
			Preferences p = new Preferences(0);
			p.ShowDialog(this);
			p.Dispose();
		}
		
		void MenuItemAboutClick(object sender, System.EventArgs e)
		{
			About a = new About();
			a.ShowDialog(this);
			a.Dispose();
		}
		
		void MenuItemGPLClick(object sender, System.EventArgs e)
		{
			GPL g = new GPL();
			g.ShowDialog(this);
			g.Dispose();
		}
		
		void ListView1SelectedChanged(object sender, System.EventArgs e)
		{
			MonoCalendar.ListView.ListViewItem item = listView2.Selected;
			if (item != null) {
				foreach (CalData aux in wc.CalendarData) {
					aux.Selected = false;
				}
				CalData cd = (CalData) item.Tag;
				cd.Selected = true;
				cd.Visible = true;
				item.Checked = true;
				wc.UpdateCalendar();
			}
		}
		
		void ListView1CheckedChanged(MonoCalendar.ListView.ListViewItem item)
		{
			if (item != null) {
				if (item != listView2.Selected) {
					CalData cd = (CalData) item.Tag;
					cd.Visible = item.Checked;
					wc.UpdateCalendar();
				} else {
					item.Checked = true;
				}
			}
		}
		
		void CloseMonoCalendar()
		{
			Config.Set("Maximized", (bool) (this.WindowState==System.Windows.Forms.FormWindowState.Maximized));
			this.WindowState=System.Windows.Forms.FormWindowState.Normal;
			Config.Set("Left", (int) this.Left);
			Config.Set("Top", (int) this.Top);
			Config.Set("Width", (int) this.ClientSize.Width);
			Config.Set("Height", (int) this.ClientSize.Height);

			string Path = System.IO.Path.Combine(System.Environment.GetFolderPath (System.Environment.SpecialFolder.Personal), ".config");
			Path = System.IO.Path.Combine(Path, "MonoCalendar");
			foreach (string files in System.IO.Directory.GetFiles(Path, "*.ics")) {
				System.IO.File.Delete(files);
			}
			foreach (CalData aux2 in wc.CalendarData) {
				aux2.SaveICS(System.IO.Path.Combine(Path, String.Format("{0}.ics", aux2.CalendarName)));
			}
			notifyIcon1.Visible = false;
			Application.Exit();
		}
		
		void MenuItemCloseClick(object sender, System.EventArgs e)
		{
			CloseMonoCalendar();
		}
		
		void MonoCalendarAppClosed(object sender, System.EventArgs e)
		{
			CloseMonoCalendar();
		}
		
		void ListView1AfterLabelEdit(MonoCalendar.ListView.ListViewItem item)
		{
			if (item != null) {
				CalData cd = (CalData) item.Tag;
				cd.CalendarName = item.Text;
			}
		}
		
		void MenuItemExportClick(object sender, System.EventArgs e)
		{
			MonoCalendar.ListView.ListViewItem item = listView2.Selected;
			if (item != null) {
				CalData cd = (CalData) item.Tag;
				System.Windows.Forms.SaveFileDialog save = new System.Windows.Forms.SaveFileDialog();
				save.Filter = "Calendarios (*.ics)|*.ics";
				save.FileName = String.Format("{0}.ics", cd.CalendarName);
				if (save.ShowDialog() == DialogResult.OK) {
					cd.SaveICS(save.FileName);
				}
				save.Dispose();
			}
		}
		
		void MenuItemImportClick(object sender, System.EventArgs e)
		{
			System.Windows.Forms.OpenFileDialog open = new System.Windows.Forms.OpenFileDialog();
			open.Filter = "Calendarios (*.ics)|*.ics";
			if (open.ShowDialog() == DialogResult.OK) {
				CalData aux = wc.NewCalData();
				aux.LoadICS(open.FileName);
				MonoCalendar.ListView.ListViewItem item1 = new MonoCalendar.ListView.ListViewItem();
				item1.Text = aux.CalendarName;
				item1.Checked = true;
				item1.Color = aux.ColorBorder;
				item1.Tag = (CalData) aux;
				listView2.Items.Add(item1);
				listView2.Selected = item1;
			}
			open.Dispose();
			wc.UpdateCalendar();
		}
		
		void MenuItemCheckUpdateClick(object sender, System.EventArgs e)
		{
			updateCalendar.CheckVersion(true);
		}
		
		void UpdateNewVersion(object sender, System.EventArgs e)
		{
			updateCalendar.Translate();
			updateCalendar.ShowDialog(this);
		}
		
		void MonoCalendarAppLoad(object sender, System.EventArgs e)
		{
			int checkUpdate = (int) MonoCalendarApp.Config.Get("CheckUpdate", (int) 2);
			if (checkUpdate > 0) {
				bool update = false;
				string last = (string) MonoCalendarApp.Config.Get("LastCheckUpdate", "20050101");
				System.DateTime lastDate = new System.DateTime(int.Parse(last.Substring(0, 4)), int.Parse(last.Substring(4, 2)), int.Parse(last.Substring(6, 2)));
				switch (checkUpdate) {
					case 1:
						update = (last != System.DateTime.Now.ToString("yyyyMMdd"));
						break;
					case 3:
						update = (lastDate.AddMonths(1) < System.DateTime.Now);
						break;
					default:
						update = (lastDate.AddDays(7) < System.DateTime.Now);
						break;
				}

				if (version != (string) Config.Get("Version", "0.0.0")) {
					Config.Set("Version", version);
					update = true;
				}
			
				if (update) {
					updateCalendar.CheckVersion(false);
					MonoCalendarApp.Config.Set("LastCheckUpdate", System.DateTime.Now.ToString("yyyyMMdd"));
				}
			}
			this.ClientSize = new System.Drawing.Size((int) Config.Get("Width", 680), (int) Config.Get("Height", 430));
			this.Left = (int) Config.Get("Left", 0);
			this.Top = (int) Config.Get("Top", 0);
			if ((bool) Config.Get("Maximized", (bool) true)) {
				this.WindowState=System.Windows.Forms.FormWindowState.Maximized;
			}
		}
		
		void ListView2KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			switch (e.KeyCode) {
				case System.Windows.Forms.Keys.Delete:
					if (listView2.Items.Count > 1) {
						MonoCalendar.ListView.ListViewItem item = listView2.Selected;
						if (listView2.Selected != null)
						{
							int pos = listView2.Items.IndexOf(item);
							CalData cd = (CalData) item.Tag;
							wc.RemoveCalendar(cd);
							listView2.Items.Remove(item);
							if (pos >= (listView2.Items.Count-1)) pos = listView2.Items.Count - 1;
							listView2.Selected = (MonoCalendar.ListView.ListViewItem) listView2.Items[pos];
						}
					}
					break;
			}
		}
		
		void MonthCalendar2DateChanged(object sender, System.EventArgs e)
		{
			wc.Date = monthCalendar2.Date;
		}
		
		void WcDateChanged(object sender, System.EventArgs e)
		{
			monthCalendar2.Date = wc.Date;
		}
		
		void WcCalendarChanged(object sender, System.EventArgs e)
		{
			foreach (CalData aux in wc.CalendarData) {
				if (aux.Selected) {
					foreach (MonoCalendar.ListView.ListViewItem item in listView2.Items) {
						if (aux == item.Tag) {
							listView2.Selected = item;
						}
					}
				}
			}
		}
		
		void MenuItemLanguageClick(object sender, System.EventArgs e)
		{
			Preferences p = new Preferences(1);
			p.ShowDialog(this);
			p.Dispose();
		}
		
		void NotifyIcon1DoubleClick(object sender, System.EventArgs e)
		{
			menuItemOpenMC.PerformClick();
		}
		
		void MonoCalendarAppClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (notifyIcon1.Visible) {
				this.Hide();
				e.Cancel = true;
			}
		}
		
		void MenuItemNotifyExitClick(object sender, System.EventArgs e)
		{
			CloseMonoCalendar();
		}
		
		void MenuItemOpenMCClick(object sender, System.EventArgs e)
		{
			this.Show();
			this.Activate();
		}
	}
}
